#ifndef __CONF_H
#define __CONF_H

#include <stdio.h>
#include <unistd.h>

#include <array.h>
#include <socket.h>
#include <joedog/joedog.h>
#include <joedog/defs.h>
#include <joedog/boolean.h>

typedef struct CONF_T *CONF;
typedef enum { PORT, NET } SCANTYPE;

CONF     new_conf();
void     conf_destroy(CONF this);
BOOLEAN  parse_rcfile(CONF this);
void     show(CONF this, BOOLEAN quit);
void     set_lower(CONF this, int i);
void     set_upper(CONF this, int i);
void     set_verbose(CONF this, BOOLEAN b);
void     set_rcfile(CONF this, char *file);
void     set_timeout(CONF this, int timeout);
void     set_address(CONF this, char *thing);
void     set_type(CONF this, SCANTYPE scantype);
void     set_protocol(CONF this, PROTOCOL protocol, BOOLEAN warn);
void     set_debug(CONF this, BOOLEAN debug);
int      get_lower(CONF this);
int      get_upper(CONF this);
int      get_timeout(CONF this);
SCANTYPE get_type(CONF this);
PROTOCOL get_protocol(CONF this);
char     *get_address(CONF this);
char     *get_rcfile(CONF this);
BOOLEAN  get_debug(CONF this);
ARRAY    get_ports(CONF this);

#endif/*__CONF_H*/
